package pico.orange.compiler;

public class Token {

	public static enum TokenValue {
		ERROR,
		EOF,
		IDENT,
		LITERAL,
		COLON,

		ORG,
		DN,
		INK,
		OUTN,
		ABYZ,
		AY,
		ST,
		LD,
		ADD,
		SUB,
		LDI,
		ADDI,
		LDYI,
		ADDYI,
		CPI,
		CPYI,
		SCALL,
		JMPF,
		CALL,
		RET,
		PUSHA,
		POPA,
		PUSHB,
		POPB,
		PUSHY,
		POPY,
		PUSHZ,
		POPZ,
		IOCTRL,
		OUT,
		IN
	};

	private TokenValue tokenValue;
	private String stringValue;
	private int intValue;
	private int line;

	public Token(TokenValue tokenValue, String stringValue, int intValue, int line) {
		this.tokenValue = tokenValue;
		this.stringValue = stringValue;
		this.intValue = intValue;
		this.line = line;
	}

	/**
	 * tokenValueを取得します。
	 *
	 * @return tokenValue
	 */
	public TokenValue getTokenValue() {
		return this.tokenValue;
	}

	/**
	 * sttingValueを取得します。
	 *
	 * @return sttingValue
	 */
	public String getStringValue() {
		return this.stringValue;
	}

	/**
	 * intValueを取得します。
	 *
	 * @return intValue
	 */
	public int getIntValue() {
		return this.intValue;
	}

	/**
	 * lineを取得します。
	 *
	 * @return line
	 */
	public int getLine() {
		return this.line;
	}

}
