package pico.orange.ide.editor;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;

import javax.swing.text.Element;
import javax.swing.text.LabelView;

import pico.orange.ide.Config;

public class CustomLabelView extends LabelView {
	final Color color = Config.TAB_COLOR;

	public CustomLabelView(Element elem) {
		super(elem);
	}

	@Override
	public void paint(Graphics g, Shape a) {
		super.paint(g, a);
		this.paintOriginalParagraph(g, a);
	}

	private void paintOriginalParagraph(Graphics g, Shape a) {
		Rectangle rec = (a instanceof Rectangle) ? (Rectangle) a : a.getBounds();
		int X = rec.x;
		int Y = rec.y;
		int HEIGHT = rec.height;
		int WIDTH = HEIGHT / 2;
		Color defaultColor = g.getColor();

		String text = this.getText(this.getStartOffset(), this.getEndOffset()).toString();
		FontMetrics fontMetrics = g.getFontMetrics();
		int space = 0;

		g.setColor(this.color);

		for (int i = 0; i < text.length(); i++) {
			int orgX = X + space + 2;
			int orgY = Y + 2;

			char word = text.charAt(i);

			switch (word) {
			case '　':
				g.drawRect(orgX, orgY, WIDTH * 2 - 6, HEIGHT - 6);
				break;
//			case ' ':
//				g.drawLine(ori_x, ori_y + HEIGHT - 8, ori_x, ori_y + HEIGHT - 6);
//				g.drawLine(ori_x + WIDTH - 4, ori_y + HEIGHT - 8, ori_x + WIDTH - 4, ori_y + HEIGHT - 6);
//				g.drawLine(ori_x, ori_y + HEIGHT - 6, ori_x + WIDTH - 4, ori_y + HEIGHT - 6);
//				break;
			case '\t':
				g.drawLine(orgX, orgY + HEIGHT / 2, orgX + WIDTH / 2, orgY + HEIGHT / 2);
				g.drawLine(orgX + WIDTH / 3, orgY + HEIGHT / 2 - HEIGHT / 6, orgX + WIDTH / 2, orgY + HEIGHT / 2);
				g.drawLine(orgX + WIDTH / 3, orgY + HEIGHT / 2 + HEIGHT / 6, orgX + WIDTH / 2, orgY + HEIGHT / 2);
				break;
			}

			if (word != '\t') {
				space += fontMetrics.stringWidth("" + word);
			} else {
				space += (int) this.getTabExpander().nextTabStop(X + space, i) - (X + space);
			}
		}

		g.setColor(defaultColor);
	}
}
