package pico.orange.ide.editor;

import javax.swing.text.AbstractDocument;
import javax.swing.text.ComponentView;
import javax.swing.text.Element;
import javax.swing.text.IconView;
import javax.swing.text.LabelView;
import javax.swing.text.StyleConstants;
import javax.swing.text.View;
import javax.swing.text.ViewFactory;

public class CustomViewFactory implements ViewFactory {

	@Override
	public View create(Element elem) {
		String kind = elem.getName();

		if (kind != null) {
			if (kind.equals(AbstractDocument.ContentElementName)) {
				return new CustomLabelView(elem);
			} else if (kind.equals(AbstractDocument.ParagraphElementName)) {
				return new CustomParagraphView(elem);
			} else if (kind.equals(AbstractDocument.SectionElementName)) {
				return new CustomBoxView(elem, View.Y_AXIS);
			} else if (kind.equals(StyleConstants.ComponentElementName)) {
				return new ComponentView(elem);
			} else if (kind.equals(StyleConstants.IconElementName)) {
				return new IconView(elem);
			}
		}
		return new LabelView(elem);
	}
}