package pico.orange.ide.editor;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;

import javax.swing.text.BadLocationException;
import javax.swing.text.BoxView;
import javax.swing.text.Element;
import javax.swing.text.Position;

import pico.orange.ide.Config;

public class CustomBoxView extends BoxView {

	public CustomBoxView(Element elem, int y) {
		super(elem, y);
	}
	
	@Override
	public void paint(Graphics g, Shape a) {
		super.paint(g, a);
		this.paintOriginalParagraph(g, a);
	}
	
	private void paintOriginalParagraph(Graphics g, Shape a) {
		try {
			Shape paragraph = this.modelToView(this.getEndOffset(), a, Position.Bias.Backward);
			Rectangle rec = (paragraph==null) ? a.getBounds() : paragraph.getBounds();
			Color defaultColor = g.getColor();
			g.setColor(Config.EOF_COLOR);
			g.drawString("[EOF]", rec.x, rec.y + rec.height - 3);
			g.setColor(defaultColor);
		} catch (BadLocationException e) {
			e.printStackTrace();
		};
		
	}
}
