package pico.orange.ide.editor;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;

import javax.swing.JPanel;
import javax.swing.JViewport;

public class Header extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int editorFontSize;
	private Insets editorMargin;
	private int height;

	Header() {
		this.editorFontSize = 0;
		this.editorMargin = new Insets(0, 0, 0, 0);
		this.height = this.getPreferredSize().height;
		this.setBackground(new Color(240, 240, 240));
		this.setForeground(Color.BLACK);
	}

	public void setEditorFontInfo(int editorFontSize, Insets editorMargin) {
		this.editorFontSize = editorFontSize;
		this.editorMargin = editorMargin;
	}

	@Override
	public void setPreferredSize(Dimension dm) {
		super.setPreferredSize(dm);
		this.height = dm.height;
	}

	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2d = (Graphics2D) g;

		final int viewPositionX = ((JViewport) this.getParent()).getViewPosition().x;
		final int WIDTH = this.getPreferredSize().width + viewPositionX;

		g2d.setFont(new Font("ＭＳ ゴシック", Font.PLAIN, 8));

		// メモリ
		if (this.editorFontSize > 0) {
			final int startIndex = viewPositionX / this.editorFontSize;
			final int startWidth = this.editorMargin.left;
			for (int i = startIndex; i < WIDTH / this.editorFontSize; i++) {
				int startHeight = this.height / 2;
				int memory = i % 10;

				if (memory == 0) {
					startHeight = this.height / 4;
				} else if (memory == 5) {
					startHeight = this.height / 3;
				} else if (memory == 1) {
					String number = "" + ((i - 1) % 100);
					g2d.drawString(number, startWidth + this.editorFontSize * i - 4, this.height - 2);
				}

				if (memory != 1) {
					g2d.drawLine(startWidth + this.editorFontSize * i, startHeight, startWidth + this.editorFontSize
							* i, this.height);
				}
			}
		}
	}
}
