package pico.orange.ide.editor;

import java.awt.Graphics;
import java.awt.Rectangle;

import javax.swing.JTextPane;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.plaf.basic.BasicTextPaneUI;
import javax.swing.text.BadLocationException;

import pico.orange.ide.Config;

public class LineHighlighter extends BasicTextPaneUI {
	private final JTextPane tc;

	public LineHighlighter(JTextPane t) {
		this.tc = t;
		this.tc.addCaretListener(new CaretListener() {
			@Override
			public void caretUpdate(CaretEvent e) {
				LineHighlighter.this.tc.repaint();
			}
		});
	}

	@Override
	public void paintBackground(Graphics g) {
		super.paintBackground(g);
		try {
			Rectangle rect = this.modelToView(this.tc, this.tc.getCaretPosition());
			int y = rect.y;
			int h = rect.height - 1;
			g.setColor(Config.UNDER_LINE_COLOR);
			g.drawLine(0, y + h, this.tc.getWidth(), y + h);
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
	}
}
